::DM_WEAPON_TYPES <- [
    {
        names = ["crowbar", "tf_weapon_crowbar"],
        displayname = "Crowbar",
        baseclass = "tf_weapon_shovel",
        baseid = 196,
        animmodel = "models/weapons/v_models/v_crowbar_mercenary.mdl",
        weaponmodel = "models/weapons/w_models/w_crowbar.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("fire rate bonus HIDDEN", 0.5, -1);
            weaponEnt.AddAttribute("damage penalty", 0.62, -1);
            weaponEnt.AddAttribute("mod crit while airborne", 1, -1);
            weaponEnt.AddAttribute("crit kill will gib", 1, -1);
            weaponEnt.AddAttribute("melee range multiplier", 1.1, -1);
            weaponEnt.AddAttribute("melee bounds multiplier", 1.1, -1);
        }
    }
    {
        names = ["pistol"],
        displayname = "Pistol",
        baseclass = "tf_weapon_pistol",
        baseid = 23,
        playerclass = TF_CLASS_SCOUT
        animmodel = "models/weapons/c_models/c_scout_arms.mdl"
    }
    {
        names = ["pocket_pistol"],
        displayname = "Pretty Boy's Pocket Pistol",
        //baseclass = "tf_weapon_handgun_scout_secondary",
        baseclass = "tf_weapon_pistol",
        playerclass = TF_CLASS_SCOUT
        baseid = 773,
        animmodel = "models/weapons/c_models/c_scout_arms.mdl"
    }
    {
        names = ["revolver"],
        displayname = "Revolver",
        baseclass = "tf_weapon_revolver",
        playerclass = TF_CLASS_SPY
        baseid = 24,
        animmodel = "models/weapons/c_models/c_spy_arms.mdl"
    }
    {
        names = ["ambassador"],
        displayname = "Ambassador",
        baseclass = "tf_weapon_revolver",
        playerclass = TF_CLASS_SPY
        baseid = 61,
        animmodel = "models/weapons/c_models/c_spy_arms.mdl"
    }
    {
        names = ["shortstop"],
        displayname = "Shortstop",
        baseclass = "tf_weapon_handgun_scout_primary",
        playerclass = TF_CLASS_SCOUT
        baseid = 220,
        animmodel = "models/weapons/c_models/c_scout_arms.mdl",
    }
    {
        names = ["force_a_nature"],
        displayname = "Force-a-Nature",
        baseclass = "tf_weapon_scattergun",
        playerclass = TF_CLASS_SCOUT
        animmodel = "models/weapons/c_models/c_scout_arms.mdl",
        baseid = 45
    }
    {
        names = ["loch_n_load"],
        displayname = "Loch-n-Load",
        baseclass = "tf_weapon_grenadelauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 308,
        animmodel = "models/weapons/c_models/c_demo_arms.mdl"
    }
    {
        names = ["shotgun"],
        displayname = "Shotgun",
        baseclass = "tf_weapon_shotgun_soldier",
        animmodel = "models/weapons/c_models/c_soldier_arms.mdl",
        playerclass = TF_CLASS_SOLDIER
        baseid = 199,
    }
    {
        names = ["family_business"],
        displayname = "Family Business",
        baseclass = "tf_weapon_shotgun_hwg",
        animmodel = "models/weapons/c_models/c_heavy_arms.mdl",
        playerclass = TF_CLASS_HEAVY
        baseid = 425,
    }
    {
        names = ["smg"],
        displayname = "SMG",
        baseclass = "tf_weapon_smg",
        playerclass = TF_CLASS_SNIPER
        baseid = 16,
        animmodel = "models/weapons/c_models/c_sniper_arms.mdl"
    }
    {
        names = ["syringe_gun"],
        displayname = "Syringe Gun",
        baseclass = "tf_weapon_syringegun_medic",
        playerclass = TF_CLASS_MEDIC
        baseid = 17,
        animmodel = "models/weapons/c_models/c_medic_arms.mdl"
    }
    {
        names = ["crusaders_crossbow"], //todo fix
        displayname = "Crusader's Crossbow",
        baseclass = "tf_weapon_crossbow",
        playerclass = TF_CLASS_MEDIC
        baseid = 305,
        animmodel = "models/weapons/c_models/c_medic_arms.mdl"
        onPullOut = function(player, weapon) {
            //weapon.AddAttribute("override projectile type", 11, -1);
        }
    }
    {
        names = ["minigun"],
        displayname = "Minigun",
        baseclass = "tf_weapon_minigun",
        playerclass = TF_CLASS_HEAVY
        baseid = 15,
        animmodel = "models/weapons/c_models/c_heavy_arms.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropIntArray(player, "m_iAmmo", 200, 1);
        }
    }
    {
        names = ["tomislav"],
        displayname = "Tomislav",
        baseclass = "tf_weapon_minigun",
        playerclass = TF_CLASS_HEAVY
        baseid = 424,
        animmodel = "models/weapons/c_models/c_heavy_arms.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            //weaponEnt.AddAttribute("aiming movespeed decreased", 5, -1);
            SetPropIntArray(player, "m_iAmmo", 200, 1);
        }
    }
    {
        names = ["rocket_launcher"],
        displayname = "Rocket Launcher",
        baseclass = "tf_weapon_rocketlauncher",
        animmodel = "models/weapons/c_models/c_soldier_arms.mdl",
        playerclass = TF_CLASS_SOLDIER
        baseid = 18,
    }
    {
        names = ["original"],
        displayname = "Rocket Launcher",
        baseclass = "tf_weapon_rocketlauncher",
        animmodel = "models/weapons/c_models/c_soldier_arms.mdl",
        playerclass = TF_CLASS_SOLDIER
        baseid = 513,
    }
    {
        names = ["liberty_launcher"],
        displayname = "Liberty Launcher",
        baseclass = "tf_weapon_rocketlauncher",
        animmodel = "models/weapons/c_models/c_soldier_arms.mdl",
        playerclass = TF_CLASS_SOLDIER
        baseid = 414,
    }
    {
        names = ["black_box"],
        displayname = "Black Box",
        baseclass = "tf_weapon_rocketlauncher",
        animmodel = "models/weapons/c_models/c_soldier_arms.mdl",
        playerclass = TF_CLASS_SOLDIER
        baseid = 228,
    }
    {
        names = ["airstrike"],
        displayname = "Airstrike",
        baseclass = "tf_weapon_rocketlauncher_airstrike",
        animmodel = "models/weapons/c_models/c_soldier_arms.mdl",
        playerclass = TF_CLASS_SOLDIER
        baseid = 1104,
    }
    {
        names = ["grenade_launcher"],
        displayname = "Grenade Launcher",
        baseclass = "tf_weapon_grenadelauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 19,
        animmodel = "models/weapons/c_models/c_demo_arms.mdl"
    }
    {
        names = ["sticky_launcher"],
        displayname = "Sticky Launcher",
        baseclass = "tf_weapon_pipebomblauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 20,
        animmodel = "models/weapons/c_models/c_demo_arms.mdl"
    }
    {
        names = ["quickie_launcher"],
        displayname = "Quickie Launcher",
        baseclass = "tf_weapon_pipebomblauncher",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 1150,
        animmodel = "models/weapons/c_models/c_demo_arms.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("stickies detonate stickies", 0, -1);
        }
    }
    {
        names = ["scattergun"],
        displayname = "Scattergun",
        baseclass = "tf_weapon_scattergun",
        playerclass = TF_CLASS_SCOUT
        baseid = 13,
        animmodel = "models/weapons/c_models/c_scout_arms.mdl",
    },
    {
        names = ["direct_hit"],
        displayname = "Direct Hit",
        baseclass = "tf_weapon_rocketlauncher_directhit",
        animmodel = "models/weapons/c_models/c_soldier_arms.mdl",
        playerclass = TF_CLASS_SOLDIER
        baseid = 127
    },
    {
        names = ["beggars_bazooka"],
        displayname = "Beggar's Bazooka",
        baseclass = "tf_weapon_rocketlauncher",
        animmodel = "models/weapons/c_models/c_soldier_arms.mdl",
        playerclass = TF_CLASS_SOLDIER
        baseid = 730
    },
    {
        names = ["sniper_rifle"],
        displayname = "Sniper Rifle",
        baseclass = "tf_weapon_sniperrifle",
        playerclass = TF_CLASS_SNIPER
        baseid = 14,
        animmodel = "models/weapons/c_models/c_sniper_arms.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("projectile penetration", 1, -1);
            SetPropIntArray(player, "m_iAmmo", 14, 1);
        }
    },
    {
        names = "rescue_ranger",
        displayname = "Rescue Ranger",
        baseclass = "tf_weapon_shotgun_building_rescue",
        playerclass = TF_CLASS_ENGINEER
        baseid = 997,
        animmodel = "models/weapons/c_models/c_engineer_arms.mdl"
    },
    {
        names = "pomson_6000",
        displayname = "Pomson 6000",
        baseclass = "tf_weapon_drg_pomson",
        playerclass = TF_CLASS_ENGINEER
        baseid = 588,
        animmodel = "models/weapons/c_models/c_engineer_arms.mdl"
    },
    {
        names = "righteous_bison",
        displayname = "Righteous Bison",
        baseclass = "tf_weapon_raygun",
        playerclass = TF_CLASS_SOLDIER
        baseid = 442,
        animmodel = "models/weapons/c_models/c_soldier_arms.mdl",
    },
    {
        names = "flaregun",
        displayname = "Flaregun",
        baseclass = "tf_weapon_flaregun",
        playerclass = TF_CLASS_PYRO
        baseid = 39,
        animmodel = "models/weapons/c_models/c_pyro_arms.mdl",
    },
    {
        names = "detonator",
        displayname = "Detonator",
        baseclass = "tf_weapon_flaregun",
        playerclass = TF_CLASS_PYRO
        baseid = 351,
        animmodel = "models/weapons/c_models/c_pyro_arms.mdl",
    },
    {
        names = "scorch_shot",
        displayname = "Scorch Shot",
        baseclass = "tf_weapon_flaregun",
        playerclass = TF_CLASS_PYRO
        baseid = 740,
        animmodel = "models/weapons/c_models/c_pyro_arms.mdl",
    },
    {
        names = ["machina"],
        displayname = "Machina",
        baseclass = "tf_weapon_sniperrifle",
        playerclass = TF_CLASS_SNIPER
        baseid = 526,
        animmodel = "models/weapons/c_models/c_sniper_arms.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("projectile penetration", 1, -1);
            SetPropIntArray(player, "m_iAmmo", 14, 1);
        }
    },
    {
        names = ["classic"],
        displayname = "Classic",
        baseclass = "tf_weapon_sniperrifle_classic",
        baseid = 1098,
        animmodel = "models/weapons/c_models/c_sniper_arms.mdl",
        playerclass = TF_CLASS_SNIPER
        OnEquip = function(player, weaponTT, weaponEnt) {
            weaponEnt.AddAttribute("projectile penetration", 1, -1);
            SetPropIntArray(player, "m_iAmmo", 14, 1);
        }
    },
    {
        names = ["huntsman"],
        displayname = "Huntsman",
        baseclass = "tf_weapon_compound_bow",
        playerclass = TF_CLASS_SNIPER
        baseid = 56,
        animmodel = "models/weapons/c_models/c_sniper_arms.mdl",
    },
    {
        names = ["loose_cannon"],
        displayname = "Loose Cannon",
        baseclass = "tf_weapon_cannon",
        playerclass = TF_CLASS_DEMOMAN
        baseid = 996,
        animmodel = "models/weapons/c_models/c_demo_arms.mdl"
    },
    {
        names = ["dragons_fury"],
        displayname = "Dragon's Fury",
        baseclass = "tf_weapon_rocketlauncher_fireball",
        animmodel = "models/weapons/c_models/c_pyro_arms.mdl",
        playerclass = TF_CLASS_PYRO
        baseid = 1178,
    },
    {
        names = ["jarate_and_bushwacka"],
        displayname = "Jarate & Bushwacka",
        baseclass = "tf_weapon_club",
        playerclass = TF_CLASS_SNIPER
        baseid = 232,
        animmodel = "models/weapons/c_models/c_sniper_arms.mdl"
        OnEquip = function(player, weaponTT, weaponEnt) {
            //PullOutWeapon(player, GetWeaponTypeByName("jarate"));
            GivePlayerWeapon2(player, "tf_weapon_jar", 58);
            /*RunWithDelayPlayer(this, 0.1, function(player) {
                TrySpawnViewModel(player).SetModelSimple("models/weapons/c_models/c_targe/c_targe.mdl");
            }, player);*/
        }
    },
    {
        names = ["jarate"],
        displayname = "Jarate & Bushwacka",
        baseclass = "tf_weapon_jar",
        baseid = 58,
        animmodel = "models/weapons/c_models/c_sniper_arms.mdl"
        playerclass = TF_CLASS_SNIPER
        OnEquip = function(player, weaponTT, weaponEnt) {
            GivePlayerWeapon2(player, "tf_weapon_jar", 58);
            /*RunWithDelayPlayer(this, 0.1, function(player) {
                TrySpawnViewModel(player).SetModelSimple("models/weapons/c_models/c_targe/c_targe.mdl");
            }, player);*/
        }
    },
    {
        names = ["eyelander_and_targe"],
        displayname = "Eyelander & Chargin' Targe",
        baseclass = "tf_weapon_sword",
        baseid = 132,
        playerclass = TF_CLASS_DEMOMAN,
        animmodel = "models/weapons/c_models/c_demo_arms.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            SetPropInt(player, "m_Shared.m_bShieldEquipped", 1);
            weaponEnt.AddAttribute("charge recharge rate increased", 1.5, -1);
            RunWithDelayPlayer(this, 0.1, function(player) {
                TrySpawnViewModel(player).SetModelSimple("models/weapons/c_models/c_targe/c_targe.mdl");
                TrySpawnWorldModel(player).SetModelSimple("models/weapons/c_models/c_targe/c_targe.mdl");
            }, player);
        }
    },
    /*{
        names = ["claymore_and_tide_turner"],
        displayname = "Claidheamh Mòr & Tide Turner",
        baseclass = "tf_weapon_bottle",
        baseid = 357,
        playerclass = TF_CLASS_DEMOMAN,
        animmodel = "models/weapons/c_models/c_demo_arms.mdl",
        weaponmodel = "models/workshop/weapons/c_models/c_claidheamohmor/c_claidheamohmor.mdl",
        onPullOut = function(player, weapon) {
            GivePlayerWeapon2(player, "tf_wearable_demoshield", 1099);
            SetPropInt(player, "m_Shared.m_bShieldEquipped", 1);
        }
    },*/
    {
        names = ["fists_of_steel"],
        displayname = "Fists Of Steel",
        baseclass = "tf_weapon_fists",
        playerclass = TF_CLASS_HEAVY
        animmodel = "models/weapons/c_models/c_heavy_arms.mdl",
        baseid = 331
    },
    {
        names = ["caber_and_splendid_screen"],
        displayname = "Caber & Splendid Screen",
        baseclass = "tf_weapon_stickbomb",
        baseid = 307,
        playerclass = TF_CLASS_DEMOMAN,
        OnEquip = function(player, weaponTT, weaponEnt) {
            GivePlayerWeapon2(player, "tf_wearable_demoshield", 406);
            SetPropInt(player, "m_Shared.m_bShieldEquipped", 1);
            RunWithDelayPlayer(this, 0.1, function(player) {
                TrySpawnWorldModel(player).SetModelSimple("models/workshop/weapons/c_models/c_persian_shield/c_persian_shield.mdl");
            }, player);
        }
    },
    {
        names = ["golden_crowbar"],
        displayname = "Golden Crowbar",
        baseclass = "tf_weapon_shovel",
        baseid = 196,
        animmodel = "models/weapons/v_models/v_crowbar_mercenary.mdl",
        weaponmodel = "models/weapons/w_models/w_crowbar_golden.mdl",
        OnEquip = function(player, weaponTT, weaponEnt) {
            player.KeyValueFromString("targetname", "player"+player.entindex());
            local mercColor = CalcMercColor(player);
            SetPropBool(SpawnEntityFromTable("tf_glow", {
                target = "player"+player.entindex()
                StartDisabled = 0
                GlowColor = mercColor[0]+" "+mercColor[1]+" "+mercColor[2]+" 255"
            }), "m_bForcePurgeFixedupStrings", true);
            weaponEnt.AddAttribute("fire rate bonus HIDDEN", 0.5, -1);
            weaponEnt.AddAttribute("damage penalty", 0.62, -1);
            weaponEnt.AddAttribute("turn to gold", 1, -1);
            weaponEnt.AddAttribute("melee range multiplier", 1.1, -1);
            weaponEnt.AddAttribute("melee bounds multiplier", 1.1, -1);
        }
    },
    {
        names = ["victory"],
        displayname = "Victory",
        baseclass = "tf_weapon_shovel",
        playerclass = TF_CLASS_SOLDIER
        baseid = 196,
    },
];

for (local i = 0; i < DM_WEAPON_TYPES.len(); i++)
    DM_WEAPON_TYPES[i].index <- i;

::GUNGAME_WEAPON_POOLS <- [
    [
        ["rocket_launcher", "original"],
        //to add flamethrowers
    ],
    [
        ["liberty_launcher", "black_box"],
        ["sticky_launcher", "quickie_launcher"],
        ["grenade_launcher", "loch_n_load", "loose_cannon"],
    ],
    [
        ["direct_hit", "beggars_bazooka", "airstrike"],
        ["minigun", "tomislav"],
        ["scattergun", "shortstop", "force_a_nature"],
        ["shotgun", "family_business"],
        ["sniper_rifle", "machina"],
        ["huntsman", "classic"],
        ["eyelander_and_targe", "eyelander_and_targe", /*"claymore_and_tide_turner",*/ /*"caber_and_splendid_screen"*/],
    ],
    [
        ["smg", "syringe_gun"/*, "crusaders_crossbow"*/],
        ["flaregun", "detonator", "scorch_shot"],
        ["righteous_bison", "rescue_ranger", "pomson_6000"],
        ["revolver", "ambassador"],
        ["pistol", /*"pocket_pistol"*/],
    ],
    [
        //["jarate_and_bushwacka", "fists_of_steel"/*, "equalizer"*/],
        ["golden_crowbar"]
    ],
    [
        ["victory"]
    ]
]

::GUNGAME_ORDER <- [];

::BuildWeaponPool <- function()
{
    foreach(majorSet in GUNGAME_WEAPON_POOLS)
        foreach(set in majorSet)
            GUNGAME_ORDER.push(set[RandomInt(0, set.len() - 1)]);
    /*foreach(majorSet in GUNGAME_WEAPON_POOLS)
        foreach(set in majorSet)
            foreach(weapon in set)
                GUNGAME_ORDER.push(weapon);*/
    foreach(weapon in GUNGAME_ORDER)
        printl(weapon);
}
BuildWeaponPool();

::GetWeaponTypeByIndex <- function(index)
{
    return index in DM_WEAPON_TYPES ? DM_WEAPON_TYPES[index] : null;
}

::GetWeaponTypeByName <- function(name)
{
    foreach (weaponTT in DM_WEAPON_TYPES)
        if (weaponTT.names.find(name) != null)
            return weaponTT;
    return null;
}

::GetWeaponTypeFromEntity <- function(weaponEntity)
{
    if (!weaponEntity)
        return null;
    local weaponScript = weaponEntity.GetScriptScope();
    if ("weaponTT" in weaponScript)
        return weaponScript.weaponTT;
    return null;
}

::FindWeaponEntityByType <-  function(player, weaponTT)
{
    for (local i = 0; i < 10; i++)
    {
        local weaponEnt = GetPropEntityArray(player, "m_hMyWeapons", i);
        if (!weaponEnt)
            continue;
        local weaponScript = weaponEnt.GetScriptScope();
        if ("weaponTT" in weaponScript && weaponScript.weaponTT == weaponTT)
            return weaponEnt;
    }
    return null;
}