FRAGS_LEFT <- {
    "0": ["player/taunt_bell.wav"]
    "1": ["vo/announcer_benja/announcer_fragsleft_01.mp3", "vo/announcer_benja/announcer_fragsleft_01_alt.mp3", "vo/announcer_benja/announcer_fragsleft_01_alt2.mp3"]
    "2": ["vo/announcer_benja/announcer_fragsleft_02.mp3", "vo/announcer_benja/announcer_fragsleft_02_alt.mp3", "vo/announcer_benja/announcer_fragsleft_02_alt2.mp3"]
    "3": ["vo/announcer_benja/announcer_fragsleft_03.mp3", "vo/announcer_benja/announcer_fragsleft_03_alt.mp3"]
    "4": ["vo/announcer_benja/announcer_fragsleft_04.mp3", "vo/announcer_benja/announcer_fragsleft_04_alt.mp3", "vo/announcer_benja/announcer_fragsleft_04_alt2.mp3"]
    "5": ["vo/announcer_benja/announcer_fragsleft_05.mp3", "vo/announcer_benja/announcer_fragsleft_05_alt.mp3", "vo/announcer_benja/announcer_fragsleft_05_alt2.mp3"]
    "10": ["vo/announcer_benja/announcer_fragsleft_10.mp3", "vo/announcer_benja/announcer_fragsleft_10_alt.mp3", "vo/announcer_benja/announcer_fragsleft_10_alt2.mp3"]
}
ROUND_START <- [
    "vo/announcer_benja/announcer_roundstart01.mp3",
    "vo/announcer_benja/announcer_roundstart02.mp3",
    "vo/announcer_benja/announcer_roundstart03.mp3",
    "vo/announcer_benja/announcer_roundstart04.mp3",
    "vo/announcer_benja/announcer_roundstart05.mp3",
    "vo/announcer_benja/announcer_roundstart06.mp3",
    "vo/announcer_benja/announcer_roundstart07.mp3",
    "vo/announcer_benja/announcer_roundstart08.mp3",
    "vo/announcer_benja/announcer_roundstart09.mp3"
]
FIGHT <- [
    "vo/announcer_benja/announcer_roundstart_fight01.mp3",
    "vo/announcer_benja/announcer_roundstart_fight02.mp3",
    "vo/announcer_benja/announcer_roundstart_fight03.mp3"
]
foreach (entry in FRAGS_LEFT)
    foreach(_, sound in entry)
        PrecacheSound(sound);
foreach (sound in ROUND_START)
    PrecacheSound(sound);
foreach (sound in FIGHT)
    PrecacheSound(sound);

announced <- {};

RunWithDelay(this, 0.5, function()
{
    EmitSoundEx({
        sound_name = ROUND_START[RandomInt(0, ROUND_START.len() - 1)],
        filter_type = RECIPIENT_FILTER_GLOBAL
    });
});
RunWithDelay(this, 4.8, function()
{
    EmitSoundEx({
        sound_name = FIGHT[RandomInt(0, FIGHT.len() - 1)],
        filter_type = RECIPIENT_FILTER_GLOBAL
    });
});

OnCustomEvent("next_weapon", 0, function(player, _)
{
    local weaponCount = GUNGAME_ORDER.len() - 1;
    local fragsLeft = (weaponCount - currentWeapons[player.entindex()])+"";
    printl(fragsLeft)
    if (fragsLeft in FRAGS_LEFT && !(fragsLeft in announced))
    {
        announced[fragsLeft] <- true;
        local soundArray = FRAGS_LEFT[fragsLeft];
        EmitSoundEx({
            sound_name = soundArray[RandomInt(0, soundArray.len() - 1)],
            filter_type = RECIPIENT_FILTER_GLOBAL
        });
    }
});