redTeam <- true;

//Make projectiles instantly collide with other players
AddTimer(-1, 0, function ()
{
    local team = redTeam ? TF_TEAM_RED : TF_TEAM_BLUE;
    for (local projectile; projectile = Entities.FindByClassname(projectile, "tf_projectile*");)
        projectile.SetTeam(team);
    redTeam = !redTeam;
});

/*OnGameEvent("crossbow_heal", 0, function(player, params)
{
    printl("healed")
})*/

AddTimer(-1, 0, function ()
{
    foreach(player in GetAlivePlayers())
    {
        if (HasTarge(player))
        {
            local charge = GetPropFloat(player, "m_Shared.m_flChargeMeter");
            if ((GetPropInt(player, "m_nButtons") & IN_ATTACK2) && charge >= 100)
                player.AddCond(TF_COND_SHIELD_CHARGE);
            if (player.InCond(TF_COND_SHIELD_CHARGE))
            {
                if (charge <= 40)
                    player.AddCondEx(TF_COND_CRITBOOSTED_PUMPKIN, 1, player);
                else if (charge <= 75)
                    player.AddCondEx(TF_COND_OFFENSEBUFF, 1, player);
                if ((GetPropInt(player, "m_nButtons") & IN_ATTACK))
                    SetPropFloat(player, "m_Shared.m_flChargeMeter", 0);
            }
        }
    }
});